

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1  Magenta
#property indicator_color2  Aqua
#property indicator_color3  Red
#property indicator_color4  LimeGreen
#property indicator_color5  DimGray
#property indicator_color6  DimGray
#property indicator_color7  Gold
#property indicator_color8  White

//
//
//
//
//

extern string ote_TimeFrames      = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-CurrentTF";
extern string TimeFrame           = "Current time frame";
extern string str_CenterLine      = "Center line settings";
extern int    CenterPrice         = 4;
extern double CenterLength        = 21;
extern double CenterPhase         = 0;
extern bool   CenterDouble        = false;
extern int    cl_style            = STYLE_SOLID;
extern string str_CenterLineWidth = "0=Thin; 2=Medium; 3=Thick; 4=Xtra thk.";
extern int    CenterLineWidth     = 0;
extern bool   CenterLineDashed    = true;

extern string str_PriceLine       = "Price line settings";
extern int    PriceType           = 8;
extern int    pl_style            = STYLE_SOLID;
extern string str_PriceLineWidth  = "0=Thin; 2=Medium; 3=Thick; 4=Xtra thk.";
extern int    PriceLineWidth      = 0;
extern bool   PriceLineDashed     = false;

extern string str_InnerLine       = "Inner envelope line settings";
extern int    InnerPrice          = 4;
extern double InnerLength         = 21;
extern double InnerPhase          = 0;
extern bool   InnerDouble         = false;
extern double InnerDeviation      = 0.382;

extern string strMid              = "Middle envelope line settings";
extern int    MidPrice            = 4;
extern double MidLength           = 21;
extern double MidPhase            = 0;
extern bool   MidDouble           = false;
extern double MidDeviation        = 0.764;

extern string strOuter            = "Outer envelope line settings";
extern int    OuterPrice          = 4;
extern double OuterLength         = 21;
extern double OuterPhase          = 0;
extern bool   OuterDouble         = false;
extern double OuterDeviation      = 1.528;
extern bool   Interpolate         = true;

extern bool   alertsOn            = true;
extern bool   alertsOnJmaCross    = true;
extern bool   alertsOnOsOb        = true;
extern bool   alertsOnExtremeOsOb = true;
extern bool   alertsOnCurrent     = false;
extern bool   alertsMessage       = true;
extern bool   alertsSound         = true;
extern bool   alertsEmail         = false;

//
//
//
//
//

double upthe[];
double dnthe[];
double uptwo[];
double dntwo[];
double upone[];
double dnone[];
double centr[];
double price[];
double trends[][3];

//
//
//
//
//

#define _tmi  0
#define _tdn1 1
#define _tdn2 2

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

int init() 
{

   if (CenterLineDashed == true) cl_style = 1;
   if (PriceLineDashed  == true) pl_style = 1;
   
   SetIndexBuffer(0,upthe); SetIndexStyle(0,DRAW_LINE,STYLE_DOT);                
   SetIndexBuffer(1,dnthe); SetIndexStyle(1,DRAW_LINE,STYLE_DOT);              
   SetIndexBuffer(2,uptwo); SetIndexStyle(2,DRAW_LINE,STYLE_DOT);               
   SetIndexBuffer(3,dntwo); SetIndexStyle(3,DRAW_LINE,STYLE_DOT);             
   SetIndexBuffer(4,upone); SetIndexStyle(4,DRAW_LINE,STYLE_DOT);                 
   SetIndexBuffer(5,dnone); SetIndexStyle(5,DRAW_LINE,STYLE_DOT);                 
   SetIndexBuffer(6,centr); SetIndexStyle(6,DRAW_LINE,cl_style,CenterLineWidth);
   SetIndexBuffer(7,price); SetIndexStyle(7,DRAW_LINE,pl_style,PriceLineWidth );
   
   //
   //
   //
   //
   //
   
   indicatorFileName = WindowExpertName();
   calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
   returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
   timeFrame         = stringToTimeFrame(TimeFrame);
   
   IndicatorShortName(timeFrameToString(timeFrame)+" jurik bands");
return (0);
}

//
//
//
//
//

int deinit() {return (0);}

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

int start() 
{       
      int counted_bars = IndicatorCounted();
      int i,r,limit;
      
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
            limit = MathMin(Bars - counted_bars,Bars-1);
            if (returnBars) { upthe[0] = MathMin(limit+1,Bars-1); return(0); }
            
      //
      //
      //
      //
      //
      
      if (calculateValue || timeFrame == Period())
      {
      
      if (ArrayRange(trends,0)!=Bars) {  ArrayResize(trends,Bars); }
         
        for (i = limit, r=Bars-i-1; i>=0; i--,r++)
        {
   
           upone[i] = (1+InnerDeviation/100)*iDSmooth(iMA(NULL,0,1,0,MODE_SMA,InnerPrice, i), InnerLength, InnerPhase, InnerDouble, i,  0);
           dnone[i] = (1-InnerDeviation/100)*iDSmooth(iMA(NULL,0,1,0,MODE_SMA,InnerPrice, i), InnerLength, InnerPhase, InnerDouble, i, 20);
           uptwo[i] = (1+MidDeviation  /100)*iDSmooth(iMA(NULL,0,1,0,MODE_SMA,MidPrice,   i), MidLength,   MidPhase,   MidDouble,   i, 40);
           dntwo[i] = (1-MidDeviation  /100)*iDSmooth(iMA(NULL,0,1,0,MODE_SMA,MidPrice,   i), MidLength,   MidPhase,   MidDouble,   i, 60);
           upthe[i] = (1+OuterDeviation/100)*iDSmooth(iMA(NULL,0,1,0,MODE_SMA,OuterPrice, i), OuterLength, OuterPhase, OuterDouble, i, 80);
           dnthe[i] = (1-OuterDeviation/100)*iDSmooth(iMA(NULL,0,1,0,MODE_SMA,OuterPrice, i), OuterLength, OuterPhase, OuterDouble, i,100);
           centr[i] =                        iDSmooth(iMA(NULL,0,1,0,MODE_SMA,CenterPrice,i), CenterLength,CenterPhase,CenterDouble,i,120);
           price[i] =  getPrice(PriceType,i);
      
           setTrends(i,r);
      
         }
   
     manageAlerts();
     return (0);
     }

     //
     //
     //
     //
     //
     
     limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
     if (ArrayRange(trends,0)!=Bars) ArrayResize(trends,Bars);
          
     for(i = limit, r=Bars-i-1; i>=0; i--,r++)
     {
      
      int y = iBarShift(NULL,timeFrame,Time[i]);
         upthe[i] = iCustom(NULL,timeFrame,indicatorFileName,"","calculateValue","",CenterPrice,CenterLength,CenterPhase,CenterDouble,cl_style,"",CenterLineWidth,CenterLineDashed,"",PriceType,pl_style,"",PriceLineWidth,
                    PriceLineDashed,"",InnerPrice,InnerLength,InnerPhase,InnerDouble,InnerDeviation,"",MidPrice,MidLength,MidPhase,MidDouble,MidDeviation,"",OuterPrice,OuterLength,OuterPhase,OuterDouble,OuterDeviation,0,y);          
         dnthe[i] = iCustom(NULL,timeFrame,indicatorFileName,"","calculateValue","",CenterPrice,CenterLength,CenterPhase,CenterDouble,cl_style,"",CenterLineWidth,CenterLineDashed,"",PriceType,pl_style,"",PriceLineWidth,
                    PriceLineDashed,"",InnerPrice,InnerLength,InnerPhase,InnerDouble,InnerDeviation,"",MidPrice,MidLength,MidPhase,MidDouble,MidDeviation,"",OuterPrice,OuterLength,OuterPhase,OuterDouble,OuterDeviation,1,y);          
         uptwo[i] = iCustom(NULL,timeFrame,indicatorFileName,"","calculateValue","",CenterPrice,CenterLength,CenterPhase,CenterDouble,cl_style,"",CenterLineWidth,CenterLineDashed,"",PriceType,pl_style,"",PriceLineWidth,
                    PriceLineDashed,"",InnerPrice,InnerLength,InnerPhase,InnerDouble,InnerDeviation,"",MidPrice,MidLength,MidPhase,MidDouble,MidDeviation,"",OuterPrice,OuterLength,OuterPhase,OuterDouble,OuterDeviation,2,y);          
         dntwo[i] = iCustom(NULL,timeFrame,indicatorFileName,"","calculateValue","",CenterPrice,CenterLength,CenterPhase,CenterDouble,cl_style,"",CenterLineWidth,CenterLineDashed,"",PriceType,pl_style,"",PriceLineWidth,
                    PriceLineDashed,"",InnerPrice,InnerLength,InnerPhase,InnerDouble,InnerDeviation,"",MidPrice,MidLength,MidPhase,MidDouble,MidDeviation,"",OuterPrice,OuterLength,OuterPhase,OuterDouble,OuterDeviation,3,y);          
         upone[i] = iCustom(NULL,timeFrame,indicatorFileName,"","calculateValue","",CenterPrice,CenterLength,CenterPhase,CenterDouble,cl_style,"",CenterLineWidth,CenterLineDashed,"",PriceType,pl_style,"",PriceLineWidth,
                    PriceLineDashed,"",InnerPrice,InnerLength,InnerPhase,InnerDouble,InnerDeviation,"",MidPrice,MidLength,MidPhase,MidDouble,MidDeviation,"",OuterPrice,OuterLength,OuterPhase,OuterDouble,OuterDeviation,4,y);          
         dnone[i] = iCustom(NULL,timeFrame,indicatorFileName,"","calculateValue","",CenterPrice,CenterLength,CenterPhase,CenterDouble,cl_style,"",CenterLineWidth,CenterLineDashed,"",PriceType,pl_style,"",PriceLineWidth,
                    PriceLineDashed,"",InnerPrice,InnerLength,InnerPhase,InnerDouble,InnerDeviation,"",MidPrice,MidLength,MidPhase,MidDouble,MidDeviation,"",OuterPrice,OuterLength,OuterPhase,OuterDouble,OuterDeviation,5,y);          
         centr[i] = iCustom(NULL,timeFrame,indicatorFileName,"","calculateValue","",CenterPrice,CenterLength,CenterPhase,CenterDouble,cl_style,"",CenterLineWidth,CenterLineDashed,"",PriceType,pl_style,"",PriceLineWidth,
                    PriceLineDashed,"",InnerPrice,InnerLength,InnerPhase,InnerDouble,InnerDeviation,"",MidPrice,MidLength,MidPhase,MidDouble,MidDeviation,"",OuterPrice,OuterLength,OuterPhase,OuterDouble,OuterDeviation,6,y);          
         price[i] = iCustom(NULL,timeFrame,indicatorFileName,"","calculateValue","",CenterPrice,CenterLength,CenterPhase,CenterDouble,cl_style,"",CenterLineWidth,CenterLineDashed,"",PriceType,pl_style,"",PriceLineWidth,
                    PriceLineDashed,"",InnerPrice,InnerLength,InnerPhase,InnerDouble,InnerDeviation,"",MidPrice,MidLength,MidPhase,MidDouble,MidDeviation,"",OuterPrice,OuterLength,OuterPhase,OuterDouble,OuterDeviation,7,y);          
                 
                    setTrends(i,r);
                 
                    //
                    //
                    //
                    //
                    //
            
                    if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

                    //
                    //
                    //
                    //
                    //

                    datetime time = iTime(NULL,timeFrame,y);
                    for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
                    for(int k = 1; k < n; k++)
                    {
  	            
  	                    upthe[i+k] = upthe[i] + (upthe[i+n] - upthe[i]) * k/n;
  	                    dnthe[i+k] = dnthe[i] + (dnthe[i+n] - dnthe[i]) * k/n;
  	                    uptwo[i+k] = uptwo[i] + (uptwo[i+n] - uptwo[i]) * k/n;
  	                    dntwo[i+k] = dntwo[i] + (dntwo[i+n] - dntwo[i]) * k/n;
  	                    upone[i+k] = upone[i] + (upone[i+n] - upone[i]) * k/n;
  	                    dnone[i+k] = dnone[i] + (dnone[i+n] - dnone[i]) * k/n;
  	                    centr[i+k] = centr[i] + (centr[i+n] - centr[i]) * k/n;
  	                    price[i+k] = price[i] + (price[i+n] - price[i]) * k/n;
  	     
                    }
   }
   
   manageAlerts();
return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

double getPrice(int type, int i)
{
   switch (type)
   {
      case 7:     return((Open[i]+Close[i])/2.0);
      case 8:     return((Open[i]+High[i]+Low[i]+Close[i])/4.0);
      default :   return(iMA(NULL,0,1,0,MODE_SMA,type,i));
   }      
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//


void setTrends(int i, int r)
{
   trends[r][_tmi]  = trends[r-1][_tmi];
   trends[r][_tdn1] = trends[r-1][_tdn1];
   trends[r][_tdn2] = trends[r-1][_tdn2];
   
      if (price[i] >  centr[i]) trends[r][_tmi]  =  1;
      if (price[i] <  centr[i]) trends[r][_tmi]  = -1;
      if (price[i] <= dnone[i]) trends[r][_tdn2] =  1;
      if (price[i] >= upone[i]) trends[r][_tdn2] = -1;
      if (price[i] <= dntwo[i]) trends[r][_tdn1] =  1;
      if (price[i] >= uptwo[i]) trends[r][_tdn1] = -1;
      
}


//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar)); 
                             whichBar = Bars-whichBar-1;

      //
      //
      //
      //
      //
            
      
      static datetime time3 = 0;
      static string   mess3 = "";
      if (alertsOnExtremeOsOb && trends[whichBar][_tdn1] != trends[whichBar-1][_tdn1])
      {
         if (trends[whichBar][_tdn1] ==  1) doAlert(time3,mess3,whichBar,"extreme oversold");
         if (trends[whichBar][_tdn1] == -1) doAlert(time3,mess3,whichBar,"extreme overbought");
      }
      static datetime time4 = 0;
      static string   mess4 = "";
      if (alertsOnOsOb && trends[whichBar][_tdn2] != trends[whichBar-1][_tdn2])
      {
         if (trends[whichBar][_tdn2] ==  1) doAlert(time4,mess4,whichBar,"oversold condition");
         if (trends[whichBar][_tdn2] == -1) doAlert(time4,mess4,whichBar,"overbought condition");
      }
      static datetime time5 = 0;
      static string   mess5 = "";
      if (alertsOnJmaCross && trends[whichBar][_tmi] != trends[whichBar-1][_tmi])
      {
         if (trends[whichBar][_tmi] ==  1) doAlert(time5,mess5,whichBar,"jma cross line up");
         if (trends[whichBar][_tmi] == -1) doAlert(time5,mess5,whichBar,"jma cross line down");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," jma bands sw ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," jma bands sw "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//
//
//
//
//

double wrk[][140];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}